from OFS.SimpleItem import SimpleItem
from zope.interface import implements
from interfaces import ITitledContent, IEditTitleContent

class EditTitleContent(SimpleItem):
    implements(ITitledContent, IEditTitleContent)
    
    meta_type = 'json_examples Edit Title Content'

    def __init__(self, id, title):
        self.id = id
        self.title = title

    def setTitle(self, value):
        'Set the title'
        self.title = value

    def getTitle(self):
        'Get the title'
        return self.title

# Product registration

from Products.PageTemplates.PageTemplateFile import PageTemplateFile

manage_addEditTitleContentForm = PageTemplateFile(
    "browser/content_add.pt", globals(),
    __name__ = 'manage_addEditTitleContentForm')

def manage_addEditTitleContent(self, id, title, REQUEST=None):
    """Add Edit Title content."""
    id = self._setObject(id, EditTitleContent(id, title))
    if REQUEST is None:
        return
    REQUEST.RESPONSE.redirect(REQUEST['URL1'] + '/manage_main')

def initialize(context):
    context.registerClass(
        EditTitleContent,
        constructors = (manage_addEditTitleContentForm,
                        manage_addEditTitleContent),
        )
