
from Products.Five import BrowserView
from cStringIO import StringIO
import datetime, time, random

class MyMethods(BrowserView):

    def my_output(self):
        'Render a simple text'
        result = StringIO()
        print >> result, "Called my_method on %s" % (self.context.absolute_url(), )
        print >> result, 'called at: %s' % datetime.datetime.now()
        return result.getvalue()

    def delayed_output(self, delay=4.0):
        'Render a simple text, with some delay'
        result = StringIO()
        started = datetime.datetime.now()
        print >> result, "Called my_method on %s" % (self.context.absolute_url(), )
        print >> result, 'Processing started: %s' % started
        time.sleep(delay)
        stopped = datetime.datetime.now()
        print >> result, 'Processing stopped: %s' % stopped
        print >> result, 'Elapsed time: %s' % (started - stopped, )
        return result.getvalue()

    def my_data(self): 
        'Return structured data'
        data = {
            'dlist': [
                {'item': 'first item', 'price': '$ 16.28'},
                {'item': 'second item', 'price': '$ 2.40'},
                {'item': 'third item', 'price': '$ 30.00'},
                {'item': 'fourth item', 'price': '$ 23.20'},
                {'item': 'fifth item', 'price': '$ 16.50'},
                {'item': 'sixth item', 'price': '$ 16.50'},
                {'item': 'seventh item', 'price': '$ 88.00'},
                {'item': 'eighth item', 'price': '$ 119.00'},
                {'item': 'nineth item', 'price': '$ 200.00'},
                {'item': 'tenth item', 'price': '$ 166.50'},
                {'item': 'eleventh item', 'price': '$ 164.40'},
                {'item': 'twelwth item', 'price': '$ 56.00'},
                {'item': 'thirteenth item', 'price': '$ 76.60'},
                ],
            'datetime': str(datetime.datetime.now()),
            }
        
        # Randomly filter out some elements
        dlist2 = []
        for elem in data['dlist']:
            if random.randrange(10) <= 5:
                dlist2.append(elem)
        data['dlist'] = dlist2
            
        return data

    def uni_data(self, second_item="INVALID", third_item="INVALID"): 
        'Return structured data, demonstrate parameters and unicode handling'
        data = {
            'item1': u'\xe1\xe9\u0171 first item',
            'item2': second_item,
            'item3': third_item,
            'datetime': str(datetime.datetime.now()),
            }
        return data
